(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***                                                                        ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/                       ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                       Privet iz Germanij                               ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros, Melkij, Strelok etc pp.                                       ***
 ***                                                                        ***
 *** Thanks to:                                                             ***
 *** W.A. Mozart, Vivaldi, Beethoven, Poeta Magica, Kurtzweyl, Manowar,     ***
 *** Blind Guardian, Weltenbrand, In Extremo, Wolfsheim, Carl Orff, Zemfira ***
 *** ... most of my work was done with their music in the background ;)     ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

procedure listproperties(window: HWND);
(*
  Functionality:
    Adds the properties from the specific structures into a listbox defined by
    the given handle.
    [SPECIFIC]
*)
var
  lastent: Pointer;
begin
  lastent := listentry;
  while lastent <> nil do
  begin
// Set the pointer value as new listbox item
    sendMessage(window, LB_ADDSTRING, 0, LongInt(lastent));
// Go to next property list item
    lastent := PPropertyList(lastent)^.nextentry;
  end;
end;

function wprops_dlgfunc(hwnd: HWND; umsg: Cardinal; wparam: WPARAM; lparam: LPARAM): BOOL; stdcall;
(*
  Functionality:
    This is the dialog callback function for the window-properties dialog.
    [SPECIFIC]
*)
var
  pdis: PDrawItemStruct;
  tm: TTextMetric;
  miscd: PMiscData;
  temps: string;
  temprect: TRect;
  pl: PPropertyList;
  tempcard: Longint;
const
  entry_maxchars = 512;
begin
  Result := TRUE;
  case umsg of
    WM_INITDIALOG:
      begin
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_WNDHANDLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_LIST1), WM_SETFONT, fix10, ord(TRUE));
        miscd := globrefpointer;
        SetDlgItemText(hwnd, IDC_STATIC_WNDHANDLE, @Format(hex_frmt, [miscd^.target_handle])[1]);
        listproperties(Getdlgitem(hwnd, IDC_LIST1));
      end;
    WM_CTLCOLORLISTBOX:
      begin
        SetBkMode(wParam, TRANSPARENT);
        SetTextColor(wParam, $0000FF00);
        result := BOOL(blackbrush);
      end;
    WM_CTLCOLORSTATIC:
      case GetDlgCtrlID(lParam) of
        IDC_STATIC_WNDHANDLE:
          begin
            SetBkMode(wParam, TRANSPARENT);
            SetTextColor(wParam, $00880000);
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
      else
        begin
          SetBkMode(wParam, TRANSPARENT);
          result := BOOL(GetSysColorBrush(COLOR_3DFACE));
        end;
      end;
    WM_CLOSE:
      begin
        EndDialog(hwnd, 0);
      end;
    WM_DRAWITEM:
      if UINT(wParam) = IDC_LIST1 then
      begin
        pdis := PDRAWITEMSTRUCT(lParam);
        if pdis^.itemID <> Cardinal(-1) then
        begin
          case pdis^.itemAction of
            ODA_SELECT,
              ODA_DRAWENTIRE:
              begin
                if pdis^.itemAction and ODA_SELECT <> 0 then
                  InvalidateRect(pdis^.hwndItem, nil, false);
                GetTextMetrics(pdis^.hDC, tm);
                tempcard := sendmessage(pdis^.hwndItem, LB_GETITEMDATA, pdis^.itemID, 0);
                if tempcard <> LB_ERR then
                begin
                  pl := pointer(tempcard);
                  case (pdis^.itemState and ODS_SELECTED = ODS_SELECTED) of
                    true:
                      begin
                        sendmessage(pdis^.hwndItem, LB_SETITEMHEIGHT, pdis^.ItemID, 5 * (tm.tmHeight + 2));
                        sendMessage(pdis^.hwndItem, LB_GETITEMRECT, pdis^.ItemID, integer(@pdis^.rcItem));
                        Fillrect(pdis^.hDC, pdis^.rcItem, blackbrush);
                        SetBkMode(pdis^.hDC, TRANSPARENT);
                        SetTextColor(pdis^.hDC, RedBrushTemplate.lbColor);
                        temps := Format('%s', [pl^.name_of_prop]);
                        TextOut(pdis^.hDC, pdis^.rcItem.Left + tm.tmAveCharWidth, pdis^.rcItem.Top + 2, @temps[1], lstrlen(@temps[1]));
                        case pl^.assigned_ref of
                          true:
                            temps := Format(val_wref, [pl^.value, pl^.pointsto]);
                        else
                          temps := Format(val_woref, [pl.value]);
                        end;
                        TextOut(pdis^.hDC, pdis^.rcItem.Left + tm.tmAveCharWidth, pdis^.rcItem.Top + tm.tmHeight + 4, @temps[1], lstrlen(@temps[1]));
                        SetTextColor(pdis^.hDC, RGB($88, $88, $FF));
                        CopyMemory(@temprect, @pdis^.rcItem, sizeof(temprect));
                        temprect.Top := temprect.Top + tm.tmHeight * 2 + 6;
                        temprect.Left := temprect.Left + tm.tmAveCharWidth;
                        temprect.Right := temprect.Right - (2 * tm.tmAveCharWidth);
                        tempcard := lstrlen(pl^.val_if_sz);
                        if tempcard > entry_maxchars then
                          tempcard := entry_maxchars;
                        DrawText(pdis^.hDC, pl^.val_if_sz, tempcard, temprect, DT_EDITCONTROL or DT_WORDBREAK);
                        SetTextColor(pdis^.hDC, RGB($FF, $FF, $FF));
                      end;
                    false:
                      begin
                        sendmessage(pdis^.hwndItem, LB_SETITEMHEIGHT, pdis^.ItemID, tm.tmHeight + 4);
                        sendMessage(pdis^.hwndItem, LB_GETITEMRECT, pdis^.ItemID, integer(@pdis^.rcItem));
                        Fillrect(pdis^.hDC, pdis^.rcItem, blackbrush);
                        SetBkMode(pdis^.hDC, TRANSPARENT);
                        SetTextColor(pdis^.hDC, GreenBrushTemplate.lbColor);
                        temps := Format('Name: %s', [pl^.name_of_prop]);
                        TextOut(pdis^.hDC, pdis^.rcItem.Left + tm.tmAveCharWidth, pdis^.rcItem.Top + 2, @temps[1], lstrlen(@temps[1]));
                        SetTextColor(pdis^.hDC, RGB($FF, $FF, $FF));
                      end;
                  end;
                  case (pdis^.itemState and ODS_SELECTED = ODS_SELECTED) of
                    TRUE:
                      DrawFocusRect(pdis^.hDC, pdis^.rcItem);
                  end;
                end;
              end;
          end;
        end;
        result := TRUE;
      end
      else
        result := false;
    WM_COMMAND:
      if HiWord(WParam) = BN_CLICKED then
        case LOWORD(wParam) of
          IDOK,
            IDCANCEL:
            SendMessage(hwnd, WM_CLOSE, 0, 0);
        end;
    WM_SYSCOMMAND:
      case wParam of
        SC_CONTEXTHELP: DialogBoxParam(hInstance, MAKEINTRESOURCE(DIALOG_HELP), hwnd, @help_dlgfunc, 1);
      else
        Result := false;
      end;
  else
    result := false;
  end;
end;

