(******************************************************************************
 ******************************************************************************
 ***                                                                        ***
 ***             Copyright (c) 1995 - 2002 by -=Assarbad [GoP]=-            ***
 ***      ____________                 ___________                          ***
 ***     /\   ________\               /\   _____  \     UIN: 281645         ***
 ***    /  \  \       /    __________/  \  \    \  \    AIM: nixlosheute    ***
 ***    \   \  \   __/___ /\   _____  \  \  \____\  \        nixahnungnicht ***
 ***     \   \  \ /\___  \  \  \    \  \  \   _______\                      ***
 ***      \   \  \ /   \  \  \  \    \  \  \  \      /  Assarbad@gmx.info   ***
 ***       \   \  \_____\  \  \  \____\  \  \  \____/                       ***
 ***        \   \___________\  \__________\  \__\                           ***
 ***         \  /           /  /          /  /  /                           ***
 ***          \/___________/ \/__________/ \/__/                            ***
 ***                                                                        ***
 ***              May the source be with you, stranger ... ;)               ***
 ***    Snizhok, eto ne tolko fruktovij kefir, snizhok, eto stil zhizn.     ***
 ***                                                                        ***
 *** Greets from -=Assarbad=- fly to YOU =)                                 ***
 *** Special greets fly 2 Nico, Casper, SA, Pizza, Navarion, Eugen, Zhenja, ***
 *** Xandros etc pp.                                                        ***
 ***                                                                        ***
 ***               [for questions/proposals drop me a mail]                 ***
 *********************************************************** ASCII by Assa ****
 ******************************************************************************)

{~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

                                 _\\|//_
                                (` * * ')
 ______________________________ooO_(_)_Ooo_____________________________________
 LEGAL STUFF:
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

 Copyright (c) 1995-2002, -=Assarbad=- ["copyright holder(s)"]
 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 1. Redistributions of source code must retain the above copyright notice, this
    list of conditions and the following disclaimer.
 2. Redistributions in binary form must reproduce the above copyright notice,
    this list of conditions and the following disclaimer in the documentation
    and/or other materials provided with the distribution.
 3. The name(s) of the copyright holder(s) may not be used to endorse or
    promote products derived from this software without specific prior written
    permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY
 DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
                             .oooO     Oooo.
 ____________________________(   )_____(   )___________________________________
                              \ (       ) /
                               \_)     (_/
 ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~}

procedure setstylestring(hwnd: HWND; which: byte; style: Cardinal);
(*
  Functionality:
    Sets the description for the different bits in the window styles 32 bit
    double word. Also the extended styles are considered.
    [GENERIC] The hwnd has to be the handle of a listbox.
*)
// Don't bother with me, because I just used literals instead of constants ;)
{$IFDEF DELPHI}
const
  // Not defined in Delphi 3/4 (I've no info about 5 & 6)
  // If I gain this information DELPHI will be changed to the appropriate version
  WS_EX_COMPOSITED = $02000000;
  WS_EX_NOACTIVATE = $08000000;
  WS_EX_LAYERED = $00080000;
  WS_EX_NOINHERITLAYOUT = $00100000;
  WS_EX_LAYOUTRTL = $00400000;
  CS_DROPSHADOW = $00020000;

{$ENDIF}

  procedure AddItem(lpstr: string);
  begin
    SendMessage(hwnd, LB_ADDSTRING, 0, Integer(@lpstr[1]));
  end;

begin
  case which of
    1:
      begin
        if (WS_OVERLAPPED and style) <> 0 then
          AddItem('WS_OVERLAPPED (= WS_TILED)');
        if (WS_MINIMIZE and style) <> 0 then
          AddItem('WS_MINIMIZE (= WS_ICONIC)');
        if (WS_THICKFRAME and style) <> 0 then
          AddItem('WS_THICKFRAME (= WS_SIZEBOX)');
        if (WS_CHILD and style) <> 0 then
          AddItem('WS_CHILD (= WS_CHILDWINDOW)');
        if (WS_POPUP and style) <> 0 then
          AddItem('WS_POPUP');
        if (WS_VISIBLE and style) <> 0 then
          AddItem('WS_VISIBLE');
        if (WS_DISABLED and style) <> 0 then
          AddItem('WS_DISABLED');
        if (WS_CLIPSIBLINGS and style) <> 0 then
          AddItem('WS_CLIPSIBLINGS');
        if (WS_CLIPCHILDREN and style) <> 0 then
          AddItem('WS_CLIPCHILDREN');
        if (WS_MAXIMIZE and style) <> 0 then
          AddItem('WS_MAXIMIZE');
        if (WS_BORDER and style) <> 0 then
          AddItem('WS_BORDER');
        if (WS_DLGFRAME and style) <> 0 then
          AddItem('WS_DLGFRAME');
        if (WS_VSCROLL and style) <> 0 then
          AddItem('WS_VSCROLL');
        if (WS_HSCROLL and style) <> 0 then
          AddItem('WS_HSCROLL');
        if (WS_SYSMENU and style) <> 0 then
          AddItem('WS_SYSMENU');
        if (WS_GROUP and style) <> 0 then
          AddItem('WS_GROUP');
        if (WS_TABSTOP and style) <> 0 then
          AddItem('WS_TABSTOP');
        if (WS_MINIMIZEBOX and style) <> 0 then
          AddItem('WS_MINIMIZEBOX');
        if (WS_MAXIMIZEBOX and style) <> 0 then
          AddItem('WS_MAXIMIZEBOX');
      {
      // Combined styles! -> are already included
            if (WS_POPUPWINDOW and style) <> 0 then AddItem('WS_POPUPWINDOW');
            if (WS_OVERLAPPEDWINDOW and style) <> 0 then AddItem('WS_OVERLAPPEDWINDOW (WS_TILEDWINDOW)');
            if (WS_CAPTION and style) <> 0 then AddItem('WS_CAPTION');
      }
      end;
    2:
      begin
        if (WS_EX_ACCEPTFILES and style) <> 0 then
          AddItem('WS_EX_ACCEPTFILES');
        if (WS_EX_APPWINDOW and style) <> 0 then
          AddItem('WS_EX_APPWINDOW');
        if (WS_EX_CLIENTEDGE and style) <> 0 then
          AddItem('WS_EX_CLIENTEDGE');
        if (WS_EX_COMPOSITED and style) <> 0 then
          AddItem('WS_EX_COMPOSITED');
        if (WS_EX_CONTEXTHELP and style) <> 0 then
          AddItem('WS_EX_CONTEXTHELP');
        if (WS_EX_CONTROLPARENT and style) <> 0 then
          AddItem('WS_EX_CONTROLPARENT');
        if (WS_EX_DLGMODALFRAME and style) <> 0 then
          AddItem('WS_EX_DLGMODALFRAME');
        if (WS_EX_LAYERED and style) <> 0 then
          AddItem('WS_EX_LAYERED');
        if (WS_EX_LAYOUTRTL and style) <> 0 then
          AddItem('WS_EX_LAYOUTRTL');
        if (WS_EX_LEFT and style) <> 0 then
          AddItem('WS_EX_LEFT');
        if (WS_EX_LEFTSCROLLBAR and style) <> 0 then
          AddItem('WS_EX_LEFTSCROLLBAR');
        if (WS_EX_LTRREADING and style) <> 0 then
          AddItem('WS_EX_LTRREADING');
        if (WS_EX_MDICHILD and style) <> 0 then
          AddItem('WS_EX_MDICHILD');
        if (WS_EX_NOACTIVATE and style) <> 0 then
          AddItem('WS_EX_NOACTIVATE');
        if (WS_EX_NOINHERITLAYOUT and style) <> 0 then
          AddItem('WS_EX_NOINHERITLAYOUT');
        if (WS_EX_NOPARENTNOTIFY and style) <> 0 then
          AddItem('WS_EX_NOPARENTNOTIFY');
        {
        // Combined exstyles! -> are already included
                if (WS_EX_OVERLAPPEDWINDOW and style)<>0 then AddItem('WS_EX_OVERLAPPEDWINDOW');
                if (WS_EX_PALETTEWINDOW and style)<>0 then AddItem('WS_EX_PALETTEWINDOW');
        }
        if (WS_EX_RIGHT and style) <> 0 then
          AddItem('WS_EX_RIGHT');
        if (WS_EX_RIGHTSCROLLBAR and style) <> 0 then
          AddItem('WS_EX_RIGHTSCROLLBAR');
        if (WS_EX_RTLREADING and style) <> 0 then
          AddItem('WS_EX_RTLREADING');
        if (WS_EX_STATICEDGE and style) <> 0 then
          AddItem('WS_EX_STATICEDGE');
        if (WS_EX_TOOLWINDOW and style) <> 0 then
          AddItem('WS_EX_TOOLWINDOW');
        if (WS_EX_TOPMOST and style) <> 0 then
          AddItem('WS_EX_TOPMOST');
        if (WS_EX_TRANSPARENT and style) <> 0 then
          AddItem('WS_EX_TRANSPARENT');
        if (WS_EX_WINDOWEDGE and style) <> 0 then
          AddItem('WS_EX_WINDOWEDGE');
      end;
    3:
      begin
        if (CS_VREDRAW and style) <> 0 then
          AddItem('CS_VREDRAW');
        if (CS_HREDRAW and style) <> 0 then
          AddItem('CS_HREDRAW');
        if (CS_DBLCLKS and style) <> 0 then
          AddItem('CS_DBLCLKS');
        if (CS_OWNDC and style) <> 0 then
          AddItem('CS_OWNDC');
        if (CS_CLASSDC and style) <> 0 then
          AddItem('CS_CLASSDC');
        if (CS_PARENTDC and style) <> 0 then
          AddItem('CS_PARENTDC');
        if (CS_NOCLOSE and style) <> 0 then
          AddItem('CS_NOCLOSE');
        if (CS_SAVEBITS and style) <> 0 then
          AddItem('CS_SAVEBITS');
        if (CS_BYTEALIGNCLIENT and style) <> 0 then
          AddItem('CS_BYTEALIGNCLIENT');
        if (CS_BYTEALIGNWINDOW and style) <> 0 then
          AddItem('CS_BYTEALIGNWINDOW');
        if (CS_GLOBALCLASS and style) <> 0 then
          AddItem('CS_GLOBALCLASS');
        if (CS_IME and style) <> 0 then
          AddItem('CS_IME');
        if (CS_DROPSHADOW and style) <> 0 then
          AddItem('CS_DROPSHADOW');
      end;
  end;
end;

function wstyles_dlgfunc(hwnd: HWND; umsg: Cardinal; wparam: WPARAM; lparam: LPARAM): BOOL; stdcall;
(*
  Functionality:
    This is the dialog callback function for the dialog that shows the extended
    and standard window styles for the target window.
    [SPECIFIC]
*)
var
  miscd: PMiscData;
begin
  Result := TRUE;
  case umsg of
    WM_INITDIALOG:
      begin
        miscd := globrefpointer;
        setstylestring(GetDlgItem(hwnd, IDC_LIST1), 1, miscd^.target_style);
        setstylestring(GetDlgItem(hwnd, IDC_LIST2), 2, miscd^.target_exstyle);
        setstylestring(GetDlgItem(hwnd, IDC_LIST3), 3, miscd^.target_classstyle);
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_STYLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_EXSTYLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_CLASSSTYLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_STYLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_EXSTYLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_CLASSSTYLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_STATIC_WINDOWHANDLE), WM_SETFONT, fix8, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_LIST1), WM_SETFONT, fix10, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_LIST2), WM_SETFONT, fix10, ord(TRUE));
        sendmessage(Getdlgitem(hwnd, IDC_LIST3), WM_SETFONT, fix10, ord(TRUE));
        SetDlgItemText(hwnd, IDC_STATIC_STYLE, @Format('0x%8.8X', [miscd^.target_style])[1]);
        SetDlgItemText(hwnd, IDC_STATIC_EXSTYLE, @Format('0x%8.8X', [miscd^.target_exstyle])[1]);
        SetDlgItemText(hwnd, IDC_STATIC_CLASSSTYLE, @Format('0x%8.8X', [miscd^.target_classstyle])[1]);
        SetDlgItemText(hwnd, IDC_STATIC_WINDOWHANDLE, @Format('0x%8.8X', [miscd^.target_handle])[1]);
      end;
    WM_CTLCOLORLISTBOX:
      begin
        SetBkMode(wParam, TRANSPARENT);
        SetTextColor(wParam, $0000FF00);
        result := BOOL(blackbrush);
      end;
    WM_CTLCOLORSTATIC:
      case GetDlgCtrlID(lParam) of
        IDC_STATIC_WINDOWHANDLESEP:
          begin
            SetBkMode(wParam, TRANSPARENT);
            SetTextColor(wParam, $00880000);
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
        IDC_STATIC_STYLE,
          IDC_STATIC_EXSTYLE,
          IDC_STATIC_CLASSSTYLE:
          begin
            SetBkMode(wParam, TRANSPARENT);
            SetTextColor(wParam, $00004400);
            result := BOOL(GetSysColorBrush(COLOR_3DFACE));
          end;
      else
        begin
          SetBkMode(wParam, TRANSPARENT);
          result := BOOL(GetSysColorBrush(COLOR_3DFACE));
        end;
      end;
    WM_CLOSE:
      begin
        EndDialog(hwnd, 0);
      end;
    WM_LBUTTONDOWN:
      begin
        sendmessage(hwnd, WM_NCLBUTTONDOWN, HTCAPTION, lParam);
      end;
    WM_COMMAND:
      if HiWord(WParam) = BN_CLICKED then
        case LOWORD(wParam) of
          IDOK,
            IDCANCEL:
            SendMessage(hwnd, WM_CLOSE, 0, 0);
        end;
  else
    result := false;
  end;
end;

